/***************************************************************************\
  "global.hpp" - Global Variables and Functions (Global Phase)
  Revision 7; 10 Nov 2002 - 15 March 2004
  Copyright (C) 2002-2004  Kevin P. Albrecht
\***************************************************************************/

#ifndef GLOBAL_HPP
#define GLOBAL_HPP

/////////////////////////
// DEFINES //////////////
/////////////////////////

// External Defines //
// GLOBAL_DEBUG or GLOBAL_RELEASE

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //
#include "k_string.hpp"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

namespace Global
{
  int nIndent;            // current indentation level
  int nCurrentLine;       // current line number
  char *sCurrentFilename; // hold current filename for error reporting
  int nTables;
  int nErrors;            // syntax errors
  bool bDebug;            // generate debug information
  bool bPrintLine;        // print source code lines in output file
  bool bOmitProgress;     // omit printing of progress during compilation

  //// Initialize global variables
  void initialize ()
  {
    nIndent = 0;
    nCurrentLine = 0;
    sCurrentFilename = k_new_s (256);
    nTables = 0;
    nErrors = 0;
    bDebug = false;
    bPrintLine = false;
    bOmitProgress = false;
  }

  void deinitialize ()
  {
    k_del_s (sCurrentFilename);
  }
}

#endif
