/***************************************************************************\
  "indentstack.hpp" - Indent Scope Stack (Phase B)
  Revision 4; 6 Dec 2002 - 15 March 2004
  Copyright (C) 2002-2003  Kevin P. Albrecht

  Note: This is a "safe" stack... instead of crashing when an element
        is accessed from an empty stack, this stack returns 0.
\***************************************************************************/

#ifndef INDENTSTACK_HPP
#define INDENTSTACK_HPP

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

class IndentStack
{
  public:
    IndentStack ();
    ~IndentStack ();

    void push (int n);
    int pop ();
    int top ();
    int size ();

  private:
    stack<int> mStack;
};

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

IndentStack::IndentStack ()
{
}

IndentStack::~IndentStack ()
{
}

void IndentStack::push (int n)
{
  mStack.push(n);
}

// returns 0 if stack empty //
int IndentStack::pop ()
{
  if (mStack.size() == 0)
  {
    return 0;
  }
  else
  {
    int temp = mStack.top();
    mStack.pop();
    return temp;
  }
}

// returns 0 if stack empty //
int IndentStack::top ()
{
  if (mStack.size() == 0)
  {
    return 0;
  }
  else
  {
    return mStack.top();
  }
}

int IndentStack::size ()
{
  return mStack.size();
}

#endif

